package com.ruoyi.business.config;

import com.ruoyi.business.xhnnotsingle.registeruser.domain.XhnRegisterUser;
import org.apache.shiro.SecurityUtils;
import org.apache.shiro.subject.Subject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.servlet.http.HttpSessionBindingEvent;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * @author wang_xy
 * @description
 * @Version 1.0
 * @params
 * @return
 * @since 2022/11/17 16:52
 */
public final class SessionHelper {
    private static Logger logger = LoggerFactory.getLogger(SessionHelper.class);

    private static final Map<String, Object> globalCache = new HashMap<String, Object>();

    public static final String CURRENT_USER = "current_user__";
    public static final String CURRENT_USER_ID = "current_user_id__";
    public static final String CURRENT_LOGIN_TIME = "current_login_time__";

    public void valueBound(HttpSessionBindingEvent event){        // TODO Auto-generated method stub

    }
    public void valueUnbound(HttpSessionBindingEvent event){        // TODO Auto-generated method stub

    }

    public static void login(Token token) {
        getSubject().login(token);
        setAttribute(CURRENT_USER, token.getUser());
        setAttribute(CURRENT_USER_ID, token.getUser().getOpenid());
        setAttribute(CURRENT_LOGIN_TIME, new Date());
    }

    public static boolean isLogined() {
        XhnRegisterUser user = getCurrentUser();
        return user != null && user.getOpenid().equals(getAttribute(CURRENT_USER_ID));
    }

    public static void setAttribute(Object key, Object value) {
        getSubject().getSession().setAttribute(key, value);
    }

    public static <T> T getAttribute(Object key, T defaultValue) {
        T obj = (T) getSubject().getSession().getAttribute(key);
        return obj != null ? obj : defaultValue;
    }

    public static <T> T getAttribute(Object key) {
        return (T) getSubject().getSession().getAttribute(key);
    }

    public static <T> T removeAttribute(Object key) {
        return (T) getSubject().getSession().removeAttribute(key);
    }

    public static XhnRegisterUser getCurrentUser() {
        return getAttribute(CURRENT_USER);
    }



    public static String getCurrentUserId() {
        if(getCurrentUser() != null){
            return getCurrentUser().getOpenid();
        }
        return "anonymous";
    }

    public static Subject getSubject() {
        return SecurityUtils.getSubject();
    }

    public void logout() {
        getSubject().logout();
        getSubject().getSession().stop();
    }

}
