package com.ruoyi.business.utils;

import com.alibaba.fastjson.JSON;
import com.aliyuncs.DefaultAcsClient;
import com.aliyuncs.IAcsClient;
import com.aliyuncs.dysmsapi.model.v20170525.SendSmsRequest;
import com.aliyuncs.dysmsapi.model.v20170525.SendSmsResponse;
import com.aliyuncs.exceptions.ClientException;
import com.aliyuncs.http.MethodType;
import com.aliyuncs.profile.DefaultProfile;
import com.aliyuncs.profile.IClientProfile;
import com.ruoyi.business.xhnnotsingle.aliyunSms.domain.XhnAliyunSms;
import com.ruoyi.common.utils.uuid.IdUtils;
import org.apache.commons.lang3.StringUtils;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * 短信验证码工具类
 * @Author wang_xy
 * @Date 2022/11/30
 * @Description TODO
 **/
public class AliyunSendSmsUtil {

    //短信API产品名称（短信产品名固定，无需修改）
    public static final String product = "Dysmsapi";
    //短信API产品域名（接口地址固定，无需修改）
    public static final String domain = "dysmsapi.aliyuncs.com";
    public static final String signName = "吉林省遇见爱传媒";
    //替换成你的AK
   public static final String accessKeyId = "LTAI5tFmkgNHgGWKs8k8fsvz";
    //你的accessKeySecret，参考本文档步骤2
   public static final String accessKeySecret = "HvdKqr2AYZ6ffX0f2EB60gFIXFtwOM";
    public static Map<String,String> codeMsg = new HashMap<>();
    public static Map<String,String> templCode = new HashMap<>();

    // 返回值code
    static {
        // TODO:  短信模板
      templCode.put("验证码","SMS_269490108");

        // 返回code对应内容
        codeMsg.put("OK","请求成功");
        codeMsg.put("isp.RAM_PERMISSION_DENY","RAM权限DENY");
        codeMsg.put("isv.OUT_OF_SERVICE","业务停机");
        codeMsg.put("isv.PRODUCT_UN_SUBSCRIPT","未开通云通信产品的阿里云客户");
        codeMsg.put("isv.PRODUCT_UNSUBSCRIBE","产品未开通");
        codeMsg.put("isv.ACCOUNT_NOT_EXISTS","账户不存在");
        codeMsg.put("isv.ACCOUNT_ABNORMAL","账户异常");
        codeMsg.put("isv.SMS_TEMPLATE_ILLEGAL","短信模板不合法");
        codeMsg.put("isv.SMS_SIGNATURE_ILLEGAL","短信签名不合法");
        codeMsg.put("isv.INVALID_PARAMETERS","参数异常");
        codeMsg.put("isp.SYSTEM_ERROR","系统错误");
        codeMsg.put("isv.MOBILE_NUMBER_ILLEGAL","非法手机号");
        codeMsg.put("isv.MOBILE_COUNT_OVER_LIMIT","手机号码数量超过限制");
        codeMsg.put("isv.TEMPLATE_MISSING_PARAMETERS","模板缺少变量");
        codeMsg.put("isv.BUSINESS_LIMIT_CONTROL","业务限流");
        codeMsg.put("isv.INVALID_JSON_PARAM","JSON参数不合法，只接受字符串值");
        codeMsg.put("isv.BLACK_KEY_CONTROL_LIMIT","黑名单管控");
        codeMsg.put("isv.PARAM_LENGTH_LIMIT","参数超出长度限制");
        codeMsg.put("isv.AMOUNT_NOT_ENOUGH","账户余额不足");
    }

    /**
     * create by xqh on 2019/5/31 15:36
     * 阿里云短信发送
     * @params [aliyunSmsService本地保存service, tempCode短信模板, dataJson模板中的变量替换JSON串, phones]
     */
    public static XhnAliyunSms sendMsg(Callback callback, String tempCode, Map<String,String> tempMap, String... phones)throws ClientException {
        String dataJson = JSON.toJSONString(tempMap);
        //设置超时时间-可自行调整
        System.setProperty("sun.net.client.defaultConnectTimeout", "10000");
        System.setProperty("sun.net.client.defaultReadTimeout", "10000");

        //初始化ascClient,暂时不支持多region（请勿修改）
        IClientProfile profile = DefaultProfile.getProfile("cn-hangzhou", accessKeyId, accessKeySecret);
        DefaultProfile.addEndpoint("cn-hangzhou", "cn-hangzhou", product, domain);
        IAcsClient acsClient = new DefaultAcsClient(profile);
        //组装请求对象
        SendSmsRequest request = new SendSmsRequest();
        //使用post提交
        request.setMethod(MethodType.POST);
        //必填:待发送手机号。支持以逗号分隔的形式进行批量调用，批量上限为1000个手机号码,批量调用相对于单条调用及时性稍有延迟,验证码类型的短信推荐使用单条调用的方式；发送国际/港澳台消息时，接收号码格式为国际区号+号码，如“85200000000”
        request.setPhoneNumbers(StringUtils.join(phones, ","));
        //必填:短信签名-可在短信控制台中找到
        request.setSignName(signName);
        //必填:短信模板-可在短信控制台中找到，发送国际/港澳台消息时，请使用国际/港澳台短信模版
        request.setTemplateCode(tempCode);
        //可选:模板中的变量替换JSON串,如模板内容为"亲爱的${name},您的验证码为${code}"时,此处的值为
        //友情提示:如果JSON中需要带换行符,请参照标准的JSON协议对换行符的要求,比如短信内容中包含\r\n的情况在JSON中需要表示成\\r\\n,否则会导致JSON在服务端解析失败
        // "{\"name\":\"Tom\", \"code\":\"123\"}"
        request.setTemplateParam(dataJson);
        //可选-上行短信扩展码(扩展码字段控制在7位或以下，无特殊需求用户请忽略此字段)
        //request.setSmsUpExtendCode("90997");
        //可选:outId为提供给业务方扩展字段,最终在短信回执消息中将此值带回给调用者
//        request.setOutId("yourOutId");
        //请求失败这里会抛ClientException异常
        SendSmsResponse sendSmsResponse = acsClient.getAcsResponse(request);

        XhnAliyunSms xhnAliyunSms = createLocal(sendSmsResponse, tempCode, dataJson, phones);
        new Thread(()->{
            callback.callback(xhnAliyunSms);
        }).start();

        return xhnAliyunSms;
    }
    /**
     * create by xqh on 2019/5/31 14:24
     * 保存本地发送短信记录
     * @params
     */
    private static XhnAliyunSms createLocal(SendSmsResponse sendSmsResponse, String tempCode, String dataJson, String... phones) {
        XhnAliyunSms xhnAliyunSms = new XhnAliyunSms();
        xhnAliyunSms.setId(IdUtils.randomUUID());
        xhnAliyunSms.setMessage(sendSmsResponse.getMessage());
        xhnAliyunSms.setRequestId(sendSmsResponse.getRequestId());
        xhnAliyunSms.setBizId(sendSmsResponse.getBizId());
        xhnAliyunSms.setCode(sendSmsResponse.getCode());
        xhnAliyunSms.setSignName(signName);
        xhnAliyunSms.setTempCode(tempCode);
        xhnAliyunSms.setDataJson(dataJson);
        xhnAliyunSms.setCount(1);
        xhnAliyunSms.setPhone(StringUtils.join(phones, ","));
        xhnAliyunSms.setCreateDate(new Date());
        return xhnAliyunSms;
    }
    public interface Callback{
        void callback(XhnAliyunSms xhnAliyunSms);
    }
}
