package com.ruoyi.business.xhn.mapper;

import com.ruoyi.business.xhn.domain.RegisteruserUnpaid;
import com.ruoyi.business.xhn.domain.XhnWxVo;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * 礼物信息Mapper接口
 *
 * @author ruoyi
 * @date 2022-11-23
 */
public interface XhnWxMapper {

    /**
     * 查询本人开盲盒记录
     * @param openid   消费人id（如果只有这个代表查询记录）
     * @param boxOpenid  盲盒人id（如果有这个代表验证是否开过此人的盲盒）
     * @return
     */
    public List<XhnWxVo> getOpenBlindBoxList(@Param("openid") String openid,@Param("boxOpenid") String boxOpenid);

    /**
     * 查询本人都收到过谁的礼物
     * @param openid
     * @return
     */
    public List<XhnWxVo> getReceivedGiftList(String openid);

    /**
     * 查询本人都送过过谁礼物
     * @param openid
     * @return
     */
    public List<XhnWxVo> getGiveGiftList(String openid);

    /**
     * 获取随机一条盲盒信息
     * @param registeruserUnpaid
     * @return
     */
    public RegisteruserUnpaid getRandomBlindBox(RegisteruserUnpaid registeruserUnpaid);

    /**
     * 当然盲盒详情
     * @param openid
     * @return
     */
    public RegisteruserUnpaid findAppUserByOpenid(String openid);

    /**
     * 查询客服信息
     * @return
     */
    public List<Map<String,Object>> getKefuInfo();

}
