package com.ruoyi.business.xhn.service.impl;

import com.ruoyi.business.config.SessionHelper;
import com.ruoyi.business.config.Token;
import com.ruoyi.business.config.WxPayConfig;
import com.ruoyi.business.utils.PayUtils;
import com.ruoyi.business.utils.QRCodeUtils;
import com.ruoyi.business.xhn.domain.PayDomain;
import com.ruoyi.business.xhn.domain.RegisteruserUnpaid;
import com.ruoyi.business.xhn.domain.XhnWxVo;
import com.ruoyi.business.xhn.mapper.XhnWxMapper;
import com.ruoyi.business.xhn.service.WxService;
import com.alibaba.fastjson.JSONObject;
import com.ruoyi.business.utils.HttpClientUtil;
import com.ruoyi.business.xhnnotsingle.activityMiddle.domain.XhnActivityMiddle;
import com.ruoyi.business.xhnnotsingle.activityMiddle.mapper.XhnActivityMiddleMapper;
import com.ruoyi.business.xhnnotsingle.consumemiddle.domain.XhnConsumeMiddle;
import com.ruoyi.business.xhnnotsingle.consumemiddle.mapper.XhnConsumeMiddleMapper;
import com.ruoyi.business.xhnnotsingle.gift.domain.XhnGift;
import com.ruoyi.business.xhnnotsingle.gift.mapper.XhnGiftMapper;
import com.ruoyi.business.xhnnotsingle.integral.domain.XhnIntegral;
import com.ruoyi.business.xhnnotsingle.integral.mapper.XhnIntegralMapper;
import com.ruoyi.business.xhnnotsingle.moneybyintegral.domain.XhnMoneybyintegral;
import com.ruoyi.business.xhnnotsingle.moneybyintegral.mapper.XhnMoneybyintegralMapper;
import com.ruoyi.business.xhnnotsingle.order.domain.XhnOrder;
import com.ruoyi.business.xhnnotsingle.order.mapper.XhnOrderMapper;
import com.ruoyi.business.xhnnotsingle.registeruser.domain.XhnRegisterUser;
import com.ruoyi.business.xhnnotsingle.registeruser.mapper.XhnRegisterUserMapper;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.utils.uuid.IdUtils;
import io.swagger.models.auth.In;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @author wang_xy
 * @description
 * @Version 1.0
 * @params
 * @return
 * @since 2022/11/21 10:32
 */
@Service
public class WxServiceImpl implements WxService {

    @Autowired
    private XhnWxMapper xhnWxMapper;
    @Autowired
    private XhnRegisterUserMapper xhnRegisterUserMapper;
    @Autowired
    private WxPayConfig wxPayConfig;
    @Autowired
    private XhnOrderMapper xhnOrderMapper;
    @Autowired
    private XhnConsumeMiddleMapper xhnConsumeMiddleMapper;
    @Autowired
    private XhnIntegralMapper xhnIntegralMapper;
    @Autowired
    private XhnMoneybyintegralMapper xhnMoneybyintegralMapper;
    @Autowired
    private XhnGiftMapper xhnGiftMapper;
    @Autowired
    private XhnActivityMiddleMapper xhnActivityMiddleMapper;

    /**
     * 微信登录
     * @param code
     * @return
     */
    public XhnRegisterUser wxLogin(String code,String promoter) {
        //1、获取微信回调接口的code
        //2、带着code，加上appid,appsecret,去请求微信官方固定地址，获取access_token
        StringBuffer baseAccessTokenUrl = new StringBuffer()
                .append("https://api.weixin.qq.com/sns/oauth2/access_token")
                .append("?appid=%s")
                .append("&secret=%s")
                .append("&code=%s")
                .append("&grant_type=authorization_code");
        String accessTokenUrl = String.format(baseAccessTokenUrl.toString(),
                PayUtils.appid,
                PayUtils.secret,
                code);

        try {
            //2.1、请求Url
            String accessTokenInfo = HttpClientUtil.get(new HttpGet(accessTokenUrl), "utf-8");
            System.out.println(accessTokenInfo);
            //3、通过返回access_token字符串后，获取access_token的值和openid的值(微信唯一id)
            JSONObject jsonObject = JSONObject.parseObject(accessTokenInfo);
            String access_token = jsonObject.getString("access_token");
            String openid = jsonObject.getString("openid");
            //4、判断数据库是否存在微信的扫描人信息，根据openid判断
            XhnRegisterUser userInfo = xhnRegisterUserMapper.selectXhnRegisterUserByOpenid(openid);
            if(userInfo == null){
                //4.1、没有则进行注册，带上access_token，openid去请求微信固定地址，获取扫描人信息
                String baseUserInfoUrl = "https://api.weixin.qq.com/sns/userinfo" +
                        "?access_token=%s" +
                        "&openid=%s";
                String userInfoUrl = String.format(baseUserInfoUrl, access_token, openid);
                String resultInfo = HttpClientUtil.get(new HttpGet(userInfoUrl),"utf-8");
                JSONObject jsonUser = JSONObject.parseObject(resultInfo);
                //解析用户信息
                //用户昵称
                String nickname = jsonUser.getString("nickname");
                //用户头像
                String headimgurl = jsonUser.getString("headimgurl");
                //4.2、获取到扫描人信息，添加进数据库
                userInfo = new XhnRegisterUser();
                userInfo.setWechatName(nickname);//微信昵称
                userInfo.setOpenid(openid);//微信唯一openid
                userInfo.setPortraitUrl(headimgurl);//用户头像
                userInfo.setApproval("0");//个人信息放进盲盒审批是否通过
                userInfo.setIsLogin("0");//是否允许登录
                userInfo.setDelisting("0");//是否脱单
                userInfo.setIsFree("0");//首充免费开盒标识
                userInfo.setCode(Integer.toString((int)((Math.random()*9+1)*100000)));
                if(StringUtils.isNotBlank(promoter) && !"null".equals(promoter)){//如果推广人不为空则保存推广人的id并为推广人加积分
                    userInfo.setPromoter(promoter);
                    XhnRegisterUser promoterUser = xhnRegisterUserMapper.selectXhnRegisterUserByOpenid(promoter);
                    promoterUser.setMemberIntegral(promoterUser.getMemberIntegral()+5);
                    xhnRegisterUserMapper.updateXhnRegisterUser(promoterUser);
                }
                String text = PayUtils.actionDomain+"qidongye?promoter="+openid;
                String ewm = QRCodeUtils.encode(text, "",true);
                userInfo.setPromoterEwm("/profile/"+ewm);
                userInfo.setCreateDate(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()) );
                xhnRegisterUserMapper.insertXhnRegisterUser(userInfo);
            }
            //5、token登录
            Token token = new Token(userInfo.getOpenid(), userInfo.getOpenid());
            token.setUser(userInfo);
            SessionHelper.login(token);
            //8、返回参数，登录成功
            return userInfo;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    @Override
    public XhnRegisterUser findUserByOpenId(String openId) {
        XhnRegisterUser user = xhnRegisterUserMapper.selectXhnRegisterUserByOpenid(openId);
        return user;
    }

    @Override
    public PayDomain getPayPrepayId(XhnRegisterUser user,String description,String total,String purpose,String boxOpenid) throws Exception {
        String out_trade_no = IdUtils.simpleUUID();//生成商品唯一订单号
        //生成订单信息存入表中
        XhnOrder order = new XhnOrder();
        order.setOrderCode(out_trade_no);
        order.setMoney(String.valueOf(Double.valueOf(total)/100.00));
        order.setOrderDate(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
        order.setState("0");
        xhnOrderMapper.insertXhnOrder(order);
        //生成订单信息存入表中
        String baseUserInfoUrl = "https://api.mch.weixin.qq.com/v3/pay/transactions/jsapi";
        //请求体内容
        JSONObject json = new JSONObject();
        json.put("appid",PayUtils.appid);
        json.put("mchid",PayUtils.mchId);
        json.put("description",description);
        json.put("out_trade_no",out_trade_no);
        json.put("notify_url",PayUtils.notifyDomain);//回调地址
        JSONObject amount = new JSONObject();
        amount.put("total",Integer.valueOf(total));
        amount.put("currency","CNY");
        json.put("amount",amount);
        JSONObject payer = new JSONObject();
        payer.put("openid",user.getOpenid());
        json.put("payer",payer);

        JSONObject attach = new JSONObject();
        attach.put("purpose",purpose);
        attach.put("gainOpenid",boxOpenid);//获得人id   开的谁的盲盒
        json.put("attach",attach.toString());//附加自定义数据用户支付成功后处理业务逻辑

        System.out.println(json.toString());
        String resultInfo = HttpClientUtil.post(new HttpPost(baseUserInfoUrl),json.toString(),"utf-8");
        JSONObject jsonUser = JSONObject.parseObject(resultInfo);
        String prepay_id = jsonUser.getString("prepay_id");

        Long timeStamp = new Date().getTime();
        String nonceStr = IdUtils.simpleUUID();
        String package_ = "prepay_id="+prepay_id;
        String paySign = wxPayConfig.getSign(PayUtils.appid, timeStamp, nonceStr, package_);
        PayDomain ret = new PayDomain();
        ret.setTimeStamp(timeStamp);
        ret.setNonceStr(nonceStr);
        ret.setPackage_(package_);
        ret.setPaySign(paySign);
        return ret;
    }

    @Override
    public void payResult(JSONObject json) throws Exception {
        JSONObject attach = JSONObject.parseObject(json.getString("attach"));//自定义返回参数
        JSONObject payer = JSONObject.parseObject(json.getString("payer"));//订单付款人信息
        JSONObject amount = JSONObject.parseObject(json.getString("amount"));//订单付款人信息
        String out_trade_no = json.getString("out_trade_no");//订单号
        XhnOrder order = new XhnOrder();
        order.setOrderCode(out_trade_no);
        order.setOrderSuccessDate(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
        order.setState("1");
        xhnOrderMapper.updateXhnOrder(order);//修改订单支付成功状态

        String purpose = attach.getString("purpose");
        XhnRegisterUser user = xhnRegisterUserMapper.selectXhnRegisterUserByOpenid(payer.getString("openid"));
        if("0".equals(purpose)){//如果是本人放入盲盒
            /**
             * 甲方要求如果是本人放入盲盒  在放入盲盒的同时有一次免费开启他人盲盒的机会
             * 修改支付本人的信息
             * 首先给支付人员一次免费的开他人盲盒机会
             * 修改盲盒为已放入
             */
            user.setIsFree("1");
            user.setApproval("1");
            xhnRegisterUserMapper.updateXhnRegisterUser(user);
            // 人员消费记录（充值）
            insertIntegral(payer.getString("openid"),"1",Double.valueOf(amount.getString("payer_total"))/100.00,"充值");
            // 人员消费记录（消费）
            insertIntegral(payer.getString("openid"),"1",Double.valueOf("-"+amount.getString("payer_total"))/100.00,"放入盲盒消费");
            SessionHelper.setAttribute(SessionHelper.CURRENT_USER, user);//更新用户信息
        }else if("1".equals(purpose)){//开其他人盲盒
            /**
             * 开其他人盲盒添加中间关联表
             */
            insertXCM(payer.getString("openid"),attach.getString("gainOpenid"),"1",null,null);
            // 人员消费记录（充值）
            insertIntegral(payer.getString("openid"),"1",Double.valueOf(amount.getString("payer_total"))/100.00,"充值");
            // 人员消费记录（消费）
            insertIntegral(payer.getString("openid"),"1",Double.valueOf("-"+amount.getString("payer_total"))/100.00,"开盲盒消费");
        }else if("2".equals(purpose)){//余额充值
            Double yuanMoney = Double.valueOf(user.getMemberMoney());//原账户金额
            Double newMoney = Double.valueOf(amount.getString("payer_total"))/100.00;//充值金额
            user.setMemberMoney(yuanMoney+newMoney);
            xhnRegisterUserMapper.updateXhnRegisterUser(user);
            // 人员消费记录（充值）
            insertIntegral(payer.getString("openid"),"1",Double.valueOf(amount.getString("payer_total"))/100.00,"余额充值");
            SessionHelper.setAttribute(SessionHelper.CURRENT_USER, user);//更新用户信息
        }else if("3".equals(purpose)){//活动报名
            insertIntegral(payer.getString("openid"),"1",Double.valueOf("-"+amount.getString("payer_total"))/100.00,"活动报名消费");
            XhnActivityMiddle xam = new XhnActivityMiddle();
            xam.setId( IdUtils.simpleUUID());
            xam.setHdId(attach.getString("gainOpenid"));
            xam.setOpenid(payer.getString("openid"));
            xhnActivityMiddleMapper.insertXhnActivityMiddle(xam);//活动报名关联表信息保存
            SessionHelper.setAttribute(SessionHelper.CURRENT_USER, user);//更新用户信息
        }
    }

    @Override
    public void moneyConvertedIntegral(String openid, String mbiId) {
        try{
            XhnRegisterUser user = xhnRegisterUserMapper.selectXhnRegisterUserByOpenid(openid);//消费人信息
            Double userMoney = user.getMemberMoney();//剩余金额
            Double userIntegral = user.getMemberIntegral();//剩余积分

            XhnMoneybyintegral xmbi = xhnMoneybyintegralMapper.selectXhnMoneybyintegralById(mbiId);//积分兑换表信息
            user.setMemberMoney(userMoney-Double.valueOf(xmbi.getMoney()));
            user.setMemberIntegral(userIntegral+Double.valueOf(xmbi.getIntegral()));
            xhnRegisterUserMapper.updateXhnRegisterUser(user);

            // 人员消费记录（充值）
            insertIntegral(openid,"2",Double.valueOf(xmbi.getIntegral()),"余额兑换积分");
            // 人员消费记录（消费）
            insertIntegral(openid,"1",Double.valueOf("-"+xmbi.getMoney()),"积分兑换扣除余额");

            SessionHelper.setAttribute(SessionHelper.CURRENT_USER, user);//更新用户信息
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    public String moneyOpenBlindBox(String openid, String boxOpenid) throws Exception {
        XhnRegisterUser user = xhnRegisterUserMapper.selectXhnRegisterUserByOpenid(openid);
        user.setMemberMoney(user.getMemberMoney()-19.90);
        xhnRegisterUserMapper.updateXhnRegisterUser(user);

        // 人员消费记录（消费）
        insertIntegral(openid,"1",-19.90,"余额开盲盒");
        // 开启盲盒中间关联表
        insertXCM(openid,boxOpenid,"1",null,null);
        SessionHelper.setAttribute(SessionHelper.CURRENT_USER, user);//更新用户信息
        return null;
    }

    @Override
    public String integralOpenBlindBox(String openid, String boxOpenid) throws Exception {
        XhnRegisterUser user = xhnRegisterUserMapper.selectXhnRegisterUserByOpenid(openid);
        user.setMemberIntegral(user.getMemberIntegral()-100.00);
        xhnRegisterUserMapper.updateXhnRegisterUser(user);

        // 人员消费记录（消费）
        insertIntegral(openid,"2",-100.00,"积分开盲盒");
        // 开启盲盒中间关联表
        insertXCM(openid,boxOpenid,"1",null,null);
        SessionHelper.setAttribute(SessionHelper.CURRENT_USER, user);//更新用户信息
        return null;
    }

    @Override
    public String freeOpenBlindBox(String openid, String boxOpenid) throws Exception {
        XhnRegisterUser user = xhnRegisterUserMapper.selectXhnRegisterUserByOpenid(openid);
        user.setIsFree("0");
        xhnRegisterUserMapper.updateXhnRegisterUser(user);
        insertXCM(openid,boxOpenid,"1",null,null);
        SessionHelper.setAttribute(SessionHelper.CURRENT_USER, user);//更新用户信息
        return null;
    }

    @Override
    public String giftGive(String openid, String bOpenid, String giftId, Integer giftNum) throws Exception {
        String ret = "您的积分剩余不足！";
        XhnRegisterUser user = xhnRegisterUserMapper.selectXhnRegisterUserByOpenid(openid);//赠送人信息
        XhnRegisterUser buser = xhnRegisterUserMapper.selectXhnRegisterUserByOpenid(bOpenid);//被赠送人信息
        XhnGift gift = xhnGiftMapper.selectXhnGiftById(giftId);
        //计算出此次礼物对应的积分数
        Double giftIntegral = gift.getGiftNum();
        Double spendIntegralAll = giftIntegral*giftNum;//总体花费积分数
        if(user.getMemberIntegral()-spendIntegralAll >= 0){
            user.setMemberIntegral(user.getMemberIntegral()-spendIntegralAll);//赠送人减去相应积分
            xhnRegisterUserMapper.updateXhnRegisterUser(user);

            buser.setMemberIntegral(buser.getMemberIntegral()+spendIntegralAll);//被赠送人加上相应积分
            xhnRegisterUserMapper.updateXhnRegisterUser(buser);

            insertXCM(openid,bOpenid,"2",giftId,giftNum);//赠送礼物后中间表记录信息

            insertIntegral(openid,"2",-spendIntegralAll,"赠送礼物");
            insertIntegral(bOpenid,"2",spendIntegralAll,"收取礼物获得");

            SessionHelper.setAttribute(SessionHelper.CURRENT_USER, user);//更新用户信息
            ret = "礼物赠送成功！";
        }
        return ret;
    }

    @Override
    public List<XhnWxVo> getOpenBlindBoxList(String openid, String boxOpenid) {
        return xhnWxMapper.getOpenBlindBoxList(openid,boxOpenid);
    }

    @Override
    public List<XhnWxVo> getReceivedGiftList(String openid) {
        return xhnWxMapper.getReceivedGiftList(openid);
    }

    @Override
    public List<XhnWxVo> getGiveGiftList(String openid) {
        return xhnWxMapper.getGiveGiftList(openid);
    }

    @Override
    public RegisteruserUnpaid getRandomBlindBox(RegisteruserUnpaid registeruserUnpaid) {
        return xhnWxMapper.getRandomBlindBox(registeruserUnpaid);
    }

    /**
     * 盲盒礼物关联表统一保存方法
     * @param openid  消费人id
     * @param boxOpenid  获得人id
     * @param type  类型  1盲盒  2礼物
     * @param giftId  礼物id
     * @param giftNum  礼物数量
     */
    public void insertXCM(String openid, String boxOpenid, String type, String giftId, Integer giftNum){
        XhnConsumeMiddle xcm = new XhnConsumeMiddle();
        xcm.setId(IdUtils.randomUUID());
        xcm.setConsumeOpenid(openid);
        xcm.setGainOpenid(boxOpenid);
        xcm.setType(type);
        if("2".equals(type)){
            xcm.setGiftId(giftId);
            xcm.setGiftNum(giftNum);
        }
        xcm.setCreateDate(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
        xhnConsumeMiddleMapper.insertXhnConsumeMiddle(xcm);
    }

    /**
     * 金额积分消费记录表
     * @param openid   消费人员id
     * @param orderType   消费类型   1金额消费  2积分消费
     * @param money  消费金额   消费为负数   获得为正数
     * @param purpose  用途   文字描述
     */
    public void insertIntegral(String openid, String orderType,Double money,String purpose){
        XhnIntegral xhnIntegral = new XhnIntegral();
        xhnIntegral.setId(IdUtils.randomUUID());
        xhnIntegral.setUserOpenid(openid);
        xhnIntegral.setMoney(money);
        xhnIntegral.setConsumeDate(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
        xhnIntegral.setOrderType(orderType);
        xhnIntegral.setPurpose(purpose);
        xhnIntegralMapper.insertXhnIntegral(xhnIntegral);
    }

    @Override
    public RegisteruserUnpaid findAppUserByOpenid(String openid) {
        return xhnWxMapper.findAppUserByOpenid(openid);
    }

    @Override
    public List<Map<String, Object>> getKefuInfo() {
        return xhnWxMapper.getKefuInfo();
    }
}
