package com.ruoyi.business.xhnnotsingle.activityInfo.controller;

import java.util.List;

import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import com.ruoyi.common.annotation.Log;
import com.ruoyi.common.enums.BusinessType;
import com.ruoyi.business.xhnnotsingle.activityInfo.domain.XhnActivityInfo;
import com.ruoyi.business.xhnnotsingle.activityInfo.service.IXhnActivityInfoService;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.utils.poi.ExcelUtil;
import com.ruoyi.common.core.page.TableDataInfo;

/**
 * 小红娘活动管理Controller
 *
 * @author ruoyi
 * @date 2022-12-08
 */
@Controller
@RequestMapping("/xhnnotsingle/activityInfo")
public class XhnActivityInfoController extends BaseController {
    private String prefix = "xhnnotsingle/activityInfo" ;

    @Autowired
    private IXhnActivityInfoService xhnActivityInfoService;

    @RequiresPermissions("xhnnotsingle:activityInfo:view")
    @GetMapping()
    public String activityInfo() {
        return prefix + "/activityInfo" ;
    }

        /**
         * 查询小红娘活动管理列表
         */
        @RequiresPermissions("xhnnotsingle:activityInfo:list")
        @PostMapping("/list")
        @ResponseBody
        public TableDataInfo list(XhnActivityInfo xhnActivityInfo) {
            startPage();
            List<XhnActivityInfo> list = xhnActivityInfoService.selectXhnActivityInfoList(xhnActivityInfo);
            return getDataTable(list);
        }

    /**
     * 导出小红娘活动管理列表
     */
    @RequiresPermissions("xhnnotsingle:activityInfo:export")
    @Log(title = "小红娘活动管理" , businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    @ResponseBody
    public AjaxResult export(XhnActivityInfo xhnActivityInfo) {
        List<XhnActivityInfo> list = xhnActivityInfoService.selectXhnActivityInfoList(xhnActivityInfo);
        ExcelUtil<XhnActivityInfo> util = new ExcelUtil<XhnActivityInfo>(XhnActivityInfo. class);
        return util.exportExcel(list, "小红娘活动管理数据");
    }

        /**
         * 新增小红娘活动管理
         */
        @GetMapping("/add")
        public String add() {
            return prefix + "/add" ;
        }

    /**
     * 新增保存小红娘活动管理
     */
    @RequiresPermissions("xhnnotsingle:activityInfo:add")
    @Log(title = "小红娘活动管理" , businessType = BusinessType.INSERT)
    @PostMapping("/add")
    @ResponseBody
    public AjaxResult addSave(XhnActivityInfo xhnActivityInfo) {
        return toAjax(xhnActivityInfoService.insertXhnActivityInfo(xhnActivityInfo));
    }

    /**
     * 修改小红娘活动管理
     */
    @RequiresPermissions("xhnnotsingle:activityInfo:edit")
    @GetMapping("/edit/{id}")
    public String edit(@PathVariable("id") String id, ModelMap mmap) {
        XhnActivityInfo xhnActivityInfo =
            xhnActivityInfoService.selectXhnActivityInfoById(id);
        mmap.put("xhnActivityInfo" , xhnActivityInfo);
        return prefix + "/edit" ;
    }

    /**
     * 修改保存小红娘活动管理
     */
    @RequiresPermissions("xhnnotsingle:activityInfo:edit")
    @Log(title = "小红娘活动管理" , businessType = BusinessType.UPDATE)
    @PostMapping("/edit")
    @ResponseBody
    public AjaxResult editSave(XhnActivityInfo xhnActivityInfo) {
        return toAjax(xhnActivityInfoService.updateXhnActivityInfo(xhnActivityInfo));
    }

        /**
         * 删除小红娘活动管理
         */
        @RequiresPermissions("xhnnotsingle:activityInfo:remove")
        @Log(title = "小红娘活动管理" , businessType = BusinessType.DELETE)
        @PostMapping("/remove")
        @ResponseBody
        public AjaxResult remove(String ids) {
            return toAjax(xhnActivityInfoService.deleteXhnActivityInfoByIds(ids));
        }
}
