package com.ruoyi.business.xhnnotsingle.activityInfo.mapper;

import java.util.List;

import com.ruoyi.business.xhnnotsingle.activityInfo.domain.XhnActivityInfo;
import org.apache.ibatis.annotations.Param;

/**
 * 小红娘活动管理Mapper接口
 *
 * @author ruoyi
 * @date 2022-12-08
 */
public interface XhnActivityInfoMapper {
    /**
     * 查询小红娘活动管理
     *
     * @param id 小红娘活动管理主键
     * @return 小红娘活动管理
     */
    public XhnActivityInfo selectXhnActivityInfoById(String id);

    /**
     * 查询小红娘活动管理列表
     *
     * @param xhnActivityInfo 小红娘活动管理
     * @return 小红娘活动管理集合
     */
    public List<XhnActivityInfo> selectXhnActivityInfoList(XhnActivityInfo xhnActivityInfo);

    /**
     * 新增小红娘活动管理
     *
     * @param xhnActivityInfo 小红娘活动管理
     * @return 结果
     */
    public int insertXhnActivityInfo(XhnActivityInfo xhnActivityInfo);

    /**
     * 修改小红娘活动管理
     *
     * @param xhnActivityInfo 小红娘活动管理
     * @return 结果
     */
    public int updateXhnActivityInfo(XhnActivityInfo xhnActivityInfo);

    /**
     * 删除小红娘活动管理
     *
     * @param id 小红娘活动管理主键
     * @return 结果
     */
    public int deleteXhnActivityInfoById(String id);

    /**
     * 批量删除小红娘活动管理
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteXhnActivityInfoByIds(String[] ids);


    /**
     * 查询活动报名人数
     *
     * @param id 小红娘活动管理主键
     * @return 结果
     */
    public Long findApplicantsNumById(String id);

    /**
     * 查询当前登录人是否报过名了
     *
     * @param id 小红娘活动管理主键
     * @return 结果
     */
    public Long findApplicantsNumByIdAndOpenId(@Param("id") String id, @Param("openid") String openid);

}
