package com.ruoyi.business.xhnnotsingle.activityInfo.service.impl;

import java.util.List;
import java.util.UUID;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.business.xhnnotsingle.activityInfo.mapper.XhnActivityInfoMapper;
import com.ruoyi.business.xhnnotsingle.activityInfo.domain.XhnActivityInfo;
import com.ruoyi.business.xhnnotsingle.activityInfo.service.IXhnActivityInfoService;
import com.ruoyi.common.core.text.Convert;

/**
 * 小红娘活动管理Service业务层处理
 *
 * @author ruoyi
 * @date 2022-12-08
 */
@Service
public class XhnActivityInfoServiceImpl implements IXhnActivityInfoService {
    @Autowired
    private XhnActivityInfoMapper xhnActivityInfoMapper;

    /**
     * 查询小红娘活动管理
     *
     * @param id 小红娘活动管理主键
     * @return 小红娘活动管理
     */
    @Override
    public XhnActivityInfo selectXhnActivityInfoById(String id) {
        return xhnActivityInfoMapper.selectXhnActivityInfoById(id);
    }

    /**
     * 查询小红娘活动管理列表
     *
     * @param xhnActivityInfo 小红娘活动管理
     * @return 小红娘活动管理
     */
    @Override
    public List<XhnActivityInfo> selectXhnActivityInfoList(XhnActivityInfo xhnActivityInfo) {
        return xhnActivityInfoMapper.selectXhnActivityInfoList(xhnActivityInfo);
    }

    /**
     * 新增小红娘活动管理
     *
     * @param xhnActivityInfo 小红娘活动管理
     * @return 结果
     */
    @Override
    public int insertXhnActivityInfo(XhnActivityInfo xhnActivityInfo) {
        xhnActivityInfo.setId(UUID.randomUUID().toString());
            return xhnActivityInfoMapper.insertXhnActivityInfo(xhnActivityInfo);
    }

    /**
     * 修改小红娘活动管理
     *
     * @param xhnActivityInfo 小红娘活动管理
     * @return 结果
     */
    @Override
    public int updateXhnActivityInfo(XhnActivityInfo xhnActivityInfo) {
        return xhnActivityInfoMapper.updateXhnActivityInfo(xhnActivityInfo);
    }

    /**
     * 批量删除小红娘活动管理
     *
     * @param ids 需要删除的小红娘活动管理主键
     * @return 结果
     */
    @Override
    public int deleteXhnActivityInfoByIds(String ids) {
        return xhnActivityInfoMapper.deleteXhnActivityInfoByIds(Convert.toStrArray(ids));
    }

    /**
     * 删除小红娘活动管理信息
     *
     * @param id 小红娘活动管理主键
     * @return 结果
     */
    @Override
    public int deleteXhnActivityInfoById(String id) {
        return xhnActivityInfoMapper.deleteXhnActivityInfoById(id);
    }

    @Override
    public Long findApplicantsNumById(String id) {
        return xhnActivityInfoMapper.findApplicantsNumById(id);
    }

    @Override
    public Long findApplicantsNumByIdAndOpenId(String id, String openid) {
        return xhnActivityInfoMapper.findApplicantsNumByIdAndOpenId(id,openid);
    }
}
