package com.ruoyi.business.xhnnotsingle.consumemiddle.controller;

import java.util.List;

import com.ruoyi.business.xhnnotsingle.consumemiddle.domain.XhnConsumeMiddle;
import com.ruoyi.business.xhnnotsingle.consumemiddle.service.IXhnConsumeMiddleService;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import com.ruoyi.common.annotation.Log;
import com.ruoyi.common.enums.BusinessType;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.utils.poi.ExcelUtil;
import com.ruoyi.common.core.page.TableDataInfo;

/**
 * 人员消费对应人员的中间关联Controller
 *
 * @author ruoyi
 * @date 2022-11-29
 */
@Controller
@RequestMapping("/system/middle")
public class XhnConsumeMiddleController extends BaseController {
    private String prefix = "system/middle" ;

    @Autowired
    private IXhnConsumeMiddleService xhnConsumeMiddleService;

    @RequiresPermissions("system:middle:view")
    @GetMapping()
    public String middle() {
        return prefix + "/middle" ;
    }

        /**
         * 查询人员消费对应人员的中间关联列表
         */
        @RequiresPermissions("system:middle:list")
        @PostMapping("/list")
        @ResponseBody
        public TableDataInfo list(XhnConsumeMiddle xhnConsumeMiddle) {
            startPage();
            List<XhnConsumeMiddle> list = xhnConsumeMiddleService.selectXhnConsumeMiddleList(xhnConsumeMiddle);
            return getDataTable(list);
        }

    /**
     * 导出人员消费对应人员的中间关联列表
     */
    @RequiresPermissions("system:middle:export")
    @Log(title = "人员消费对应人员的中间关联" , businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    @ResponseBody
    public AjaxResult export(XhnConsumeMiddle xhnConsumeMiddle) {
        List<XhnConsumeMiddle> list = xhnConsumeMiddleService.selectXhnConsumeMiddleList(xhnConsumeMiddle);
        ExcelUtil<XhnConsumeMiddle> util = new ExcelUtil<XhnConsumeMiddle>(XhnConsumeMiddle. class);
        return util.exportExcel(list, "人员消费对应人员的中间关联数据");
    }

        /**
         * 新增人员消费对应人员的中间关联
         */
        @GetMapping("/add")
        public String add() {
            return prefix + "/add" ;
        }

    /**
     * 新增保存人员消费对应人员的中间关联
     */
    @RequiresPermissions("system:middle:add")
    @Log(title = "人员消费对应人员的中间关联" , businessType = BusinessType.INSERT)
    @PostMapping("/add")
    @ResponseBody
    public AjaxResult addSave(XhnConsumeMiddle xhnConsumeMiddle) {
        return toAjax(xhnConsumeMiddleService.insertXhnConsumeMiddle(xhnConsumeMiddle));
    }

    /**
     * 修改人员消费对应人员的中间关联
     */
    @RequiresPermissions("system:middle:edit")
    @GetMapping("/edit/{id}")
    public String edit(@PathVariable("id") String id, ModelMap mmap) {
        XhnConsumeMiddle xhnConsumeMiddle =
            xhnConsumeMiddleService.selectXhnConsumeMiddleById(id);
        mmap.put("xhnConsumeMiddle" , xhnConsumeMiddle);
        return prefix + "/edit" ;
    }

    /**
     * 修改保存人员消费对应人员的中间关联
     */
    @RequiresPermissions("system:middle:edit")
    @Log(title = "人员消费对应人员的中间关联" , businessType = BusinessType.UPDATE)
    @PostMapping("/edit")
    @ResponseBody
    public AjaxResult editSave(XhnConsumeMiddle xhnConsumeMiddle) {
        return toAjax(xhnConsumeMiddleService.updateXhnConsumeMiddle(xhnConsumeMiddle));
    }

        /**
         * 删除人员消费对应人员的中间关联
         */
        @RequiresPermissions("system:middle:remove")
        @Log(title = "人员消费对应人员的中间关联" , businessType = BusinessType.DELETE)
        @PostMapping("/remove")
        @ResponseBody
        public AjaxResult remove(String ids) {
            return toAjax(xhnConsumeMiddleService.deleteXhnConsumeMiddleByIds(ids));
        }
}
