package com.ruoyi.business.xhnnotsingle.consumemiddle.mapper;

import com.ruoyi.business.xhnnotsingle.consumemiddle.domain.XhnConsumeMiddle;

import java.util.List;


/**
 * 人员消费对应人员的中间关联Mapper接口
 *
 * @author ruoyi
 * @date 2022-11-29
 */
public interface XhnConsumeMiddleMapper {
    /**
     * 查询人员消费对应人员的中间关联
     *
     * @param id 人员消费对应人员的中间关联主键
     * @return 人员消费对应人员的中间关联
     */
    public XhnConsumeMiddle selectXhnConsumeMiddleById(String id);

    /**
     * 查询人员消费对应人员的中间关联列表
     *
     * @param xhnConsumeMiddle 人员消费对应人员的中间关联
     * @return 人员消费对应人员的中间关联集合
     */
    public List<XhnConsumeMiddle> selectXhnConsumeMiddleList(XhnConsumeMiddle xhnConsumeMiddle);

    /**
     * 新增人员消费对应人员的中间关联
     *
     * @param xhnConsumeMiddle 人员消费对应人员的中间关联
     * @return 结果
     */
    public int insertXhnConsumeMiddle(XhnConsumeMiddle xhnConsumeMiddle);

    /**
     * 修改人员消费对应人员的中间关联
     *
     * @param xhnConsumeMiddle 人员消费对应人员的中间关联
     * @return 结果
     */
    public int updateXhnConsumeMiddle(XhnConsumeMiddle xhnConsumeMiddle);

    /**
     * 删除人员消费对应人员的中间关联
     *
     * @param id 人员消费对应人员的中间关联主键
     * @return 结果
     */
    public int deleteXhnConsumeMiddleById(String id);

    /**
     * 批量删除人员消费对应人员的中间关联
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteXhnConsumeMiddleByIds(String[] ids);
}
