package com.ruoyi.business.xhnnotsingle.consumemiddle.service.impl;

import java.util.List;

import com.ruoyi.business.xhnnotsingle.consumemiddle.domain.XhnConsumeMiddle;
import com.ruoyi.business.xhnnotsingle.consumemiddle.mapper.XhnConsumeMiddleMapper;
import com.ruoyi.business.xhnnotsingle.consumemiddle.service.IXhnConsumeMiddleService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.common.core.text.Convert;

/**
 * 人员消费对应人员的中间关联Service业务层处理
 *
 * @author ruoyi
 * @date 2022-11-29
 */
@Service
public class XhnConsumeMiddleServiceImpl implements IXhnConsumeMiddleService {
    @Autowired
    private XhnConsumeMiddleMapper xhnConsumeMiddleMapper;

    /**
     * 查询人员消费对应人员的中间关联
     *
     * @param id 人员消费对应人员的中间关联主键
     * @return 人员消费对应人员的中间关联
     */
    @Override
    public XhnConsumeMiddle selectXhnConsumeMiddleById(String id) {
        return xhnConsumeMiddleMapper.selectXhnConsumeMiddleById(id);
    }

    /**
     * 查询人员消费对应人员的中间关联列表
     *
     * @param xhnConsumeMiddle 人员消费对应人员的中间关联
     * @return 人员消费对应人员的中间关联
     */
    @Override
    public List<XhnConsumeMiddle> selectXhnConsumeMiddleList(XhnConsumeMiddle xhnConsumeMiddle) {
        return xhnConsumeMiddleMapper.selectXhnConsumeMiddleList(xhnConsumeMiddle);
    }

    /**
     * 新增人员消费对应人员的中间关联
     *
     * @param xhnConsumeMiddle 人员消费对应人员的中间关联
     * @return 结果
     */
    @Override
    public int insertXhnConsumeMiddle(XhnConsumeMiddle xhnConsumeMiddle) {
            return xhnConsumeMiddleMapper.insertXhnConsumeMiddle(xhnConsumeMiddle);
    }

    /**
     * 修改人员消费对应人员的中间关联
     *
     * @param xhnConsumeMiddle 人员消费对应人员的中间关联
     * @return 结果
     */
    @Override
    public int updateXhnConsumeMiddle(XhnConsumeMiddle xhnConsumeMiddle) {
        return xhnConsumeMiddleMapper.updateXhnConsumeMiddle(xhnConsumeMiddle);
    }

    /**
     * 批量删除人员消费对应人员的中间关联
     *
     * @param ids 需要删除的人员消费对应人员的中间关联主键
     * @return 结果
     */
    @Override
    public int deleteXhnConsumeMiddleByIds(String ids) {
        return xhnConsumeMiddleMapper.deleteXhnConsumeMiddleByIds(Convert.toStrArray(ids));
    }

    /**
     * 删除人员消费对应人员的中间关联信息
     *
     * @param id 人员消费对应人员的中间关联主键
     * @return 结果
     */
    @Override
    public int deleteXhnConsumeMiddleById(String id) {
        return xhnConsumeMiddleMapper.deleteXhnConsumeMiddleById(id);
    }
}
