package com.ruoyi.business.xhnnotsingle.gift.service;

import java.util.List;

import com.ruoyi.business.xhnnotsingle.gift.domain.XhnGift;

/**
 * 礼物信息Service接口
 *
 * @author ruoyi
 * @date 2022-11-23
 */
public interface IXhnGiftService {
    /**
     * 查询礼物信息
     *
     * @param id 礼物信息主键
     * @return 礼物信息
     */
    public XhnGift selectXhnGiftById(String id);

    /**
     * 查询礼物信息列表
     *
     * @param xhnGift 礼物信息
     * @return 礼物信息集合
     */
    public List<XhnGift> selectXhnGiftList(XhnGift xhnGift);

    /**
     * 新增礼物信息
     *
     * @param xhnGift 礼物信息
     * @return 结果
     */
    public int insertXhnGift(XhnGift xhnGift);

    /**
     * 修改礼物信息
     *
     * @param xhnGift 礼物信息
     * @return 结果
     */
    public int updateXhnGift(XhnGift xhnGift);

    /**
     * 批量删除礼物信息
     *
     * @param ids 需要删除的礼物信息主键集合
     * @return 结果
     */
    public int deleteXhnGiftByIds(String ids);

    /**
     * 删除礼物信息信息
     *
     * @param id 礼物信息主键
     * @return 结果
     */
    public int deleteXhnGiftById(String id);
}
