package com.ruoyi.business.xhnnotsingle.gift.service.impl;

import java.util.List;

import com.ruoyi.common.utils.uuid.IdUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.business.xhnnotsingle.gift.mapper.XhnGiftMapper;
import com.ruoyi.business.xhnnotsingle.gift.domain.XhnGift;
import com.ruoyi.business.xhnnotsingle.gift.service.IXhnGiftService;
import com.ruoyi.common.core.text.Convert;

/**
 * 礼物信息Service业务层处理
 *
 * @author ruoyi
 * @date 2022-11-23
 */
@Service
public class XhnGiftServiceImpl implements IXhnGiftService {
    @Autowired
    private XhnGiftMapper xhnGiftMapper;

    /**
     * 查询礼物信息
     *
     * @param id 礼物信息主键
     * @return 礼物信息
     */
    @Override
    public XhnGift selectXhnGiftById(String id) {
        return xhnGiftMapper.selectXhnGiftById(id);
    }

    /**
     * 查询礼物信息列表
     *
     * @param xhnGift 礼物信息
     * @return 礼物信息
     */
    @Override
    public List<XhnGift> selectXhnGiftList(XhnGift xhnGift) {
        return xhnGiftMapper.selectXhnGiftList(xhnGift);
    }

    /**
     * 新增礼物信息
     *
     * @param xhnGift 礼物信息
     * @return 结果
     */
    @Override
    public int insertXhnGift(XhnGift xhnGift) {
        xhnGift.setId(IdUtils.randomUUID());
            return xhnGiftMapper.insertXhnGift(xhnGift);
    }

    /**
     * 修改礼物信息
     *
     * @param xhnGift 礼物信息
     * @return 结果
     */
    @Override
    public int updateXhnGift(XhnGift xhnGift) {
        return xhnGiftMapper.updateXhnGift(xhnGift);
    }

    /**
     * 批量删除礼物信息
     *
     * @param ids 需要删除的礼物信息主键
     * @return 结果
     */
    @Override
    public int deleteXhnGiftByIds(String ids) {
        return xhnGiftMapper.deleteXhnGiftByIds(Convert.toStrArray(ids));
    }

    /**
     * 删除礼物信息信息
     *
     * @param id 礼物信息主键
     * @return 结果
     */
    @Override
    public int deleteXhnGiftById(String id) {
        return xhnGiftMapper.deleteXhnGiftById(id);
    }
}
