package com.ruoyi.business.xhnnotsingle.integral.controller;

import java.util.List;

import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import com.ruoyi.common.annotation.Log;
import com.ruoyi.common.enums.BusinessType;
import com.ruoyi.business.xhnnotsingle.integral.domain.XhnIntegral;
import com.ruoyi.business.xhnnotsingle.integral.service.IXhnIntegralService;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.utils.poi.ExcelUtil;
import com.ruoyi.common.core.page.TableDataInfo;

/**
 * 小红娘金额、积分充值消费记录Controller
 *
 * @author ruoyi
 * @date 2022-11-30
 */
@Controller
@RequestMapping("/xhnnotsingle/integral")
public class XhnIntegralController extends BaseController {
    private String prefix = "xhnnotsingle/integral" ;

    @Autowired
    private IXhnIntegralService xhnIntegralService;

    @RequiresPermissions("xhnnotsingle:integral:view")
    @GetMapping()
    public String integral() {
        return prefix + "/integral" ;
    }

        /**
         * 查询小红娘金额、积分充值消费记录列表
         */
        @RequiresPermissions("xhnnotsingle:integral:list")
        @PostMapping("/list")
        @ResponseBody
        public TableDataInfo list(XhnIntegral xhnIntegral) {
            startPage();
            List<XhnIntegral> list = xhnIntegralService.selectXhnIntegralList(xhnIntegral);
            return getDataTable(list);
        }

    /**
     * 导出小红娘金额、积分充值消费记录列表
     */
    @RequiresPermissions("xhnnotsingle:integral:export")
    @Log(title = "小红娘金额、积分充值消费记录" , businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    @ResponseBody
    public AjaxResult export(XhnIntegral xhnIntegral) {
        List<XhnIntegral> list = xhnIntegralService.selectXhnIntegralList(xhnIntegral);
        ExcelUtil<XhnIntegral> util = new ExcelUtil<XhnIntegral>(XhnIntegral. class);
        return util.exportExcel(list, "小红娘金额、积分充值消费记录数据");
    }

        /**
         * 新增小红娘金额、积分充值消费记录
         */
        @GetMapping("/add")
        public String add() {
            return prefix + "/add" ;
        }

    /**
     * 新增保存小红娘金额、积分充值消费记录
     */
    @RequiresPermissions("xhnnotsingle:integral:add")
    @Log(title = "小红娘金额、积分充值消费记录" , businessType = BusinessType.INSERT)
    @PostMapping("/add")
    @ResponseBody
    public AjaxResult addSave(XhnIntegral xhnIntegral) {
        return toAjax(xhnIntegralService.insertXhnIntegral(xhnIntegral));
    }

    /**
     * 修改小红娘金额、积分充值消费记录
     */
    @RequiresPermissions("xhnnotsingle:integral:edit")
    @GetMapping("/edit/{id}")
    public String edit(@PathVariable("id") String id, ModelMap mmap) {
        XhnIntegral xhnIntegral =
            xhnIntegralService.selectXhnIntegralById(id);
        mmap.put("xhnIntegral" , xhnIntegral);
        return prefix + "/edit" ;
    }

    /**
     * 修改保存小红娘金额、积分充值消费记录
     */
    @RequiresPermissions("xhnnotsingle:integral:edit")
    @Log(title = "小红娘金额、积分充值消费记录" , businessType = BusinessType.UPDATE)
    @PostMapping("/edit")
    @ResponseBody
    public AjaxResult editSave(XhnIntegral xhnIntegral) {
        return toAjax(xhnIntegralService.updateXhnIntegral(xhnIntegral));
    }

        /**
         * 删除小红娘金额、积分充值消费记录
         */
        @RequiresPermissions("xhnnotsingle:integral:remove")
        @Log(title = "小红娘金额、积分充值消费记录" , businessType = BusinessType.DELETE)
        @PostMapping("/remove")
        @ResponseBody
        public AjaxResult remove(String ids) {
            return toAjax(xhnIntegralService.deleteXhnIntegralByIds(ids));
        }
}
