package com.ruoyi.business.xhnnotsingle.integral.service.impl;

import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.business.xhnnotsingle.integral.mapper.XhnIntegralMapper;
import com.ruoyi.business.xhnnotsingle.integral.domain.XhnIntegral;
import com.ruoyi.business.xhnnotsingle.integral.service.IXhnIntegralService;
import com.ruoyi.common.core.text.Convert;

/**
 * 小红娘金额、积分充值消费记录Service业务层处理
 *
 * @author ruoyi
 * @date 2022-11-30
 */
@Service
public class XhnIntegralServiceImpl implements IXhnIntegralService {
    @Autowired
    private XhnIntegralMapper xhnIntegralMapper;

    /**
     * 查询小红娘金额、积分充值消费记录
     *
     * @param id 小红娘金额、积分充值消费记录主键
     * @return 小红娘金额、积分充值消费记录
     */
    @Override
    public XhnIntegral selectXhnIntegralById(String id) {
        return xhnIntegralMapper.selectXhnIntegralById(id);
    }

    /**
     * 查询小红娘金额、积分充值消费记录列表
     *
     * @param xhnIntegral 小红娘金额、积分充值消费记录
     * @return 小红娘金额、积分充值消费记录
     */
    @Override
    public List<XhnIntegral> selectXhnIntegralList(XhnIntegral xhnIntegral) {
        return xhnIntegralMapper.selectXhnIntegralList(xhnIntegral);
    }

    /**
     * 新增小红娘金额、积分充值消费记录
     *
     * @param xhnIntegral 小红娘金额、积分充值消费记录
     * @return 结果
     */
    @Override
    public int insertXhnIntegral(XhnIntegral xhnIntegral) {
            return xhnIntegralMapper.insertXhnIntegral(xhnIntegral);
    }

    /**
     * 修改小红娘金额、积分充值消费记录
     *
     * @param xhnIntegral 小红娘金额、积分充值消费记录
     * @return 结果
     */
    @Override
    public int updateXhnIntegral(XhnIntegral xhnIntegral) {
        return xhnIntegralMapper.updateXhnIntegral(xhnIntegral);
    }

    /**
     * 批量删除小红娘金额、积分充值消费记录
     *
     * @param ids 需要删除的小红娘金额、积分充值消费记录主键
     * @return 结果
     */
    @Override
    public int deleteXhnIntegralByIds(String ids) {
        return xhnIntegralMapper.deleteXhnIntegralByIds(Convert.toStrArray(ids));
    }

    /**
     * 删除小红娘金额、积分充值消费记录信息
     *
     * @param id 小红娘金额、积分充值消费记录主键
     * @return 结果
     */
    @Override
    public int deleteXhnIntegralById(String id) {
        return xhnIntegralMapper.deleteXhnIntegralById(id);
    }
}
