package com.ruoyi.business.xhnnotsingle.matchmaker.controller;

import java.util.List;

import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import com.ruoyi.common.annotation.Log;
import com.ruoyi.common.enums.BusinessType;
import com.ruoyi.business.xhnnotsingle.matchmaker.domain.XhnMatchmaker;
import com.ruoyi.business.xhnnotsingle.matchmaker.service.IXhnMatchmakerService;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.utils.poi.ExcelUtil;
import com.ruoyi.common.core.page.TableDataInfo;

/**
 * 小红娘店铺红娘信息Controller
 *
 * @author ruoyi
 * @date 2022-12-08
 */
@Controller
@RequestMapping("/xhnnotsingle/matchmaker")
public class XhnMatchmakerController extends BaseController {
    private String prefix = "xhnnotsingle/matchmaker" ;

    @Autowired
    private IXhnMatchmakerService xhnMatchmakerService;

    @RequiresPermissions("xhnnotsingle:matchmaker:view")
    @GetMapping()
    public String matchmaker() {
        return prefix + "/matchmaker" ;
    }

        /**
         * 查询小红娘店铺红娘信息列表
         */
        @RequiresPermissions("xhnnotsingle:matchmaker:list")
        @PostMapping("/list")
        @ResponseBody
        public TableDataInfo list(XhnMatchmaker xhnMatchmaker) {
            startPage();
            List<XhnMatchmaker> list = xhnMatchmakerService.selectXhnMatchmakerList(xhnMatchmaker);
            return getDataTable(list);
        }

    /**
     * 导出小红娘店铺红娘信息列表
     */
    @RequiresPermissions("xhnnotsingle:matchmaker:export")
    @Log(title = "小红娘店铺红娘信息" , businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    @ResponseBody
    public AjaxResult export(XhnMatchmaker xhnMatchmaker) {
        List<XhnMatchmaker> list = xhnMatchmakerService.selectXhnMatchmakerList(xhnMatchmaker);
        ExcelUtil<XhnMatchmaker> util = new ExcelUtil<XhnMatchmaker>(XhnMatchmaker. class);
        return util.exportExcel(list, "小红娘店铺红娘信息数据");
    }

        /**
         * 新增小红娘店铺红娘信息
         */
        @GetMapping("/add")
        public String add() {
            return prefix + "/add" ;
        }

    /**
     * 新增保存小红娘店铺红娘信息
     */
    @RequiresPermissions("xhnnotsingle:matchmaker:add")
    @Log(title = "小红娘店铺红娘信息" , businessType = BusinessType.INSERT)
    @PostMapping("/add")
    @ResponseBody
    public AjaxResult addSave(XhnMatchmaker xhnMatchmaker) {
        return toAjax(xhnMatchmakerService.insertXhnMatchmaker(xhnMatchmaker));
    }

    /**
     * 修改小红娘店铺红娘信息
     */
    @RequiresPermissions("xhnnotsingle:matchmaker:edit")
    @GetMapping("/edit/{id}")
    public String edit(@PathVariable("id") String id, ModelMap mmap) {
        XhnMatchmaker xhnMatchmaker =
            xhnMatchmakerService.selectXhnMatchmakerById(id);
        mmap.put("xhnMatchmaker" , xhnMatchmaker);
        return prefix + "/edit" ;
    }

    /**
     * 修改保存小红娘店铺红娘信息
     */
    @RequiresPermissions("xhnnotsingle:matchmaker:edit")
    @Log(title = "小红娘店铺红娘信息" , businessType = BusinessType.UPDATE)
    @PostMapping("/edit")
    @ResponseBody
    public AjaxResult editSave(XhnMatchmaker xhnMatchmaker) {
        return toAjax(xhnMatchmakerService.updateXhnMatchmaker(xhnMatchmaker));
    }

        /**
         * 删除小红娘店铺红娘信息
         */
        @RequiresPermissions("xhnnotsingle:matchmaker:remove")
        @Log(title = "小红娘店铺红娘信息" , businessType = BusinessType.DELETE)
        @PostMapping("/remove")
        @ResponseBody
        public AjaxResult remove(String ids) {
            return toAjax(xhnMatchmakerService.deleteXhnMatchmakerByIds(ids));
        }
}
