package com.ruoyi.business.xhnnotsingle.matchmaker.service.impl;

import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.business.xhnnotsingle.matchmaker.mapper.XhnMatchmakerMapper;
import com.ruoyi.business.xhnnotsingle.matchmaker.domain.XhnMatchmaker;
import com.ruoyi.business.xhnnotsingle.matchmaker.service.IXhnMatchmakerService;
import com.ruoyi.common.core.text.Convert;

/**
 * 小红娘店铺红娘信息Service业务层处理
 *
 * @author ruoyi
 * @date 2022-12-08
 */
@Service
public class XhnMatchmakerServiceImpl implements IXhnMatchmakerService {
    @Autowired
    private XhnMatchmakerMapper xhnMatchmakerMapper;

    /**
     * 查询小红娘店铺红娘信息
     *
     * @param id 小红娘店铺红娘信息主键
     * @return 小红娘店铺红娘信息
     */
    @Override
    public XhnMatchmaker selectXhnMatchmakerById(String id) {
        return xhnMatchmakerMapper.selectXhnMatchmakerById(id);
    }

    /**
     * 查询小红娘店铺红娘信息列表
     *
     * @param xhnMatchmaker 小红娘店铺红娘信息
     * @return 小红娘店铺红娘信息
     */
    @Override
    public List<XhnMatchmaker> selectXhnMatchmakerList(XhnMatchmaker xhnMatchmaker) {
        return xhnMatchmakerMapper.selectXhnMatchmakerList(xhnMatchmaker);
    }

    /**
     * 新增小红娘店铺红娘信息
     *
     * @param xhnMatchmaker 小红娘店铺红娘信息
     * @return 结果
     */
    @Override
    public int insertXhnMatchmaker(XhnMatchmaker xhnMatchmaker) {
            return xhnMatchmakerMapper.insertXhnMatchmaker(xhnMatchmaker);
    }

    /**
     * 修改小红娘店铺红娘信息
     *
     * @param xhnMatchmaker 小红娘店铺红娘信息
     * @return 结果
     */
    @Override
    public int updateXhnMatchmaker(XhnMatchmaker xhnMatchmaker) {
        return xhnMatchmakerMapper.updateXhnMatchmaker(xhnMatchmaker);
    }

    /**
     * 批量删除小红娘店铺红娘信息
     *
     * @param ids 需要删除的小红娘店铺红娘信息主键
     * @return 结果
     */
    @Override
    public int deleteXhnMatchmakerByIds(String ids) {
        return xhnMatchmakerMapper.deleteXhnMatchmakerByIds(Convert.toStrArray(ids));
    }

    /**
     * 删除小红娘店铺红娘信息信息
     *
     * @param id 小红娘店铺红娘信息主键
     * @return 结果
     */
    @Override
    public int deleteXhnMatchmakerById(String id) {
        return xhnMatchmakerMapper.deleteXhnMatchmakerById(id);
    }
}
