package com.ruoyi.business.xhnnotsingle.moneybyintegral.controller;

import java.util.List;

import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import com.ruoyi.common.annotation.Log;
import com.ruoyi.common.enums.BusinessType;
import com.ruoyi.business.xhnnotsingle.moneybyintegral.domain.XhnMoneybyintegral;
import com.ruoyi.business.xhnnotsingle.moneybyintegral.service.IXhnMoneybyintegralService;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.utils.poi.ExcelUtil;
import com.ruoyi.common.core.page.TableDataInfo;

/**
 * 小红娘金额兑换积分Controller
 *
 * @author ruoyi
 * @date 2022-11-23
 */
@Controller
@RequestMapping("/xhnnotsingle/moneybyintegral")
public class XhnMoneybyintegralController extends BaseController {
    private String prefix = "xhnnotsingle/moneybyintegral" ;

    @Autowired
    private IXhnMoneybyintegralService xhnMoneybyintegralService;

    @RequiresPermissions("xhnnotsingle:moneybyintegral:view")
    @GetMapping()
    public String moneybyintegral() {
        return prefix + "/moneybyintegral" ;
    }

        /**
         * 查询小红娘金额兑换积分列表
         */
        @RequiresPermissions("xhnnotsingle:moneybyintegral:list")
        @PostMapping("/list")
        @ResponseBody
        public TableDataInfo list(XhnMoneybyintegral xhnMoneybyintegral) {
            startPage();
            List<XhnMoneybyintegral> list = xhnMoneybyintegralService.selectXhnMoneybyintegralList(xhnMoneybyintegral);
            return getDataTable(list);
        }

    /**
     * 导出小红娘金额兑换积分列表
     */
    @RequiresPermissions("xhnnotsingle:moneybyintegral:export")
    @Log(title = "小红娘金额兑换积分" , businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    @ResponseBody
    public AjaxResult export(XhnMoneybyintegral xhnMoneybyintegral) {
        List<XhnMoneybyintegral> list = xhnMoneybyintegralService.selectXhnMoneybyintegralList(xhnMoneybyintegral);
        ExcelUtil<XhnMoneybyintegral> util = new ExcelUtil<XhnMoneybyintegral>(XhnMoneybyintegral. class);
        return util.exportExcel(list, "小红娘金额兑换积分数据");
    }

        /**
         * 新增小红娘金额兑换积分
         */
        @GetMapping("/add")
        public String add() {
            return prefix + "/add" ;
        }

    /**
     * 新增保存小红娘金额兑换积分
     */
    @RequiresPermissions("xhnnotsingle:moneybyintegral:add")
    @Log(title = "小红娘金额兑换积分" , businessType = BusinessType.INSERT)
    @PostMapping("/add")
    @ResponseBody
    public AjaxResult addSave(XhnMoneybyintegral xhnMoneybyintegral) {
        return toAjax(xhnMoneybyintegralService.insertXhnMoneybyintegral(xhnMoneybyintegral));
    }

    /**
     * 修改小红娘金额兑换积分
     */
    @RequiresPermissions("xhnnotsingle:moneybyintegral:edit")
    @GetMapping("/edit/{id}")
    public String edit(@PathVariable("id") String id, ModelMap mmap) {
        XhnMoneybyintegral xhnMoneybyintegral =
            xhnMoneybyintegralService.selectXhnMoneybyintegralById(id);
        mmap.put("xhnMoneybyintegral" , xhnMoneybyintegral);
        return prefix + "/edit" ;
    }

    /**
     * 修改保存小红娘金额兑换积分
     */
    @RequiresPermissions("xhnnotsingle:moneybyintegral:edit")
    @Log(title = "小红娘金额兑换积分" , businessType = BusinessType.UPDATE)
    @PostMapping("/edit")
    @ResponseBody
    public AjaxResult editSave(XhnMoneybyintegral xhnMoneybyintegral) {
        return toAjax(xhnMoneybyintegralService.updateXhnMoneybyintegral(xhnMoneybyintegral));
    }

        /**
         * 删除小红娘金额兑换积分
         */
        @RequiresPermissions("xhnnotsingle:moneybyintegral:remove")
        @Log(title = "小红娘金额兑换积分" , businessType = BusinessType.DELETE)
        @PostMapping("/remove")
        @ResponseBody
        public AjaxResult remove(String ids) {
            return toAjax(xhnMoneybyintegralService.deleteXhnMoneybyintegralByIds(ids));
        }
}
