package com.ruoyi.business.xhnnotsingle.moneybyintegral.service.impl;

import java.util.List;

import com.ruoyi.common.utils.uuid.IdUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.business.xhnnotsingle.moneybyintegral.mapper.XhnMoneybyintegralMapper;
import com.ruoyi.business.xhnnotsingle.moneybyintegral.domain.XhnMoneybyintegral;
import com.ruoyi.business.xhnnotsingle.moneybyintegral.service.IXhnMoneybyintegralService;
import com.ruoyi.common.core.text.Convert;

/**
 * 小红娘金额兑换积分Service业务层处理
 *
 * @author ruoyi
 * @date 2022-11-23
 */
@Service
public class XhnMoneybyintegralServiceImpl implements IXhnMoneybyintegralService {
    @Autowired
    private XhnMoneybyintegralMapper xhnMoneybyintegralMapper;

    /**
     * 查询小红娘金额兑换积分
     *
     * @param id 小红娘金额兑换积分主键
     * @return 小红娘金额兑换积分
     */
    @Override
    public XhnMoneybyintegral selectXhnMoneybyintegralById(String id) {
        return xhnMoneybyintegralMapper.selectXhnMoneybyintegralById(id);
    }

    /**
     * 查询小红娘金额兑换积分列表
     *
     * @param xhnMoneybyintegral 小红娘金额兑换积分
     * @return 小红娘金额兑换积分
     */
    @Override
    public List<XhnMoneybyintegral> selectXhnMoneybyintegralList(XhnMoneybyintegral xhnMoneybyintegral) {
        return xhnMoneybyintegralMapper.selectXhnMoneybyintegralList(xhnMoneybyintegral);
    }

    /**
     * 新增小红娘金额兑换积分
     *
     * @param xhnMoneybyintegral 小红娘金额兑换积分
     * @return 结果
     */
    @Override
    public int insertXhnMoneybyintegral(XhnMoneybyintegral xhnMoneybyintegral) {
        xhnMoneybyintegral.setId(IdUtils.simpleUUID());
            return xhnMoneybyintegralMapper.insertXhnMoneybyintegral(xhnMoneybyintegral);
    }

    /**
     * 修改小红娘金额兑换积分
     *
     * @param xhnMoneybyintegral 小红娘金额兑换积分
     * @return 结果
     */
    @Override
    public int updateXhnMoneybyintegral(XhnMoneybyintegral xhnMoneybyintegral) {
        return xhnMoneybyintegralMapper.updateXhnMoneybyintegral(xhnMoneybyintegral);
    }

    /**
     * 批量删除小红娘金额兑换积分
     *
     * @param ids 需要删除的小红娘金额兑换积分主键
     * @return 结果
     */
    @Override
    public int deleteXhnMoneybyintegralByIds(String ids) {
        return xhnMoneybyintegralMapper.deleteXhnMoneybyintegralByIds(Convert.toStrArray(ids));
    }

    /**
     * 删除小红娘金额兑换积分信息
     *
     * @param id 小红娘金额兑换积分主键
     * @return 结果
     */
    @Override
    public int deleteXhnMoneybyintegralById(Long id) {
        return xhnMoneybyintegralMapper.deleteXhnMoneybyintegralById(id);
    }
}
