package com.ruoyi.business.xhnnotsingle.order.mapper;

import java.util.List;

import com.ruoyi.business.xhnnotsingle.order.domain.XhnOrder;

/**
 * 微信充值订单Mapper接口
 *
 * @author ruoyi
 * @date 2022-11-29
 */
public interface XhnOrderMapper {
    /**
     * 查询微信充值订单
     *
     * @param orderCode 微信充值订单主键
     * @return 微信充值订单
     */
    public XhnOrder selectXhnOrderByOrderCode(String orderCode);

    /**
     * 查询微信充值订单列表
     *
     * @param xhnOrder 微信充值订单
     * @return 微信充值订单集合
     */
    public List<XhnOrder> selectXhnOrderList(XhnOrder xhnOrder);

    /**
     * 新增微信充值订单
     *
     * @param xhnOrder 微信充值订单
     * @return 结果
     */
    public int insertXhnOrder(XhnOrder xhnOrder);

    /**
     * 修改微信充值订单
     *
     * @param xhnOrder 微信充值订单
     * @return 结果
     */
    public int updateXhnOrder(XhnOrder xhnOrder);

    /**
     * 删除微信充值订单
     *
     * @param orderCode 微信充值订单主键
     * @return 结果
     */
    public int deleteXhnOrderByOrderCode(String orderCode);

    /**
     * 批量删除微信充值订单
     *
     * @param orderCodes 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteXhnOrderByOrderCodes(String[] orderCodes);
}
