package com.ruoyi.business.xhnnotsingle.order.service.impl;

import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.business.xhnnotsingle.order.mapper.XhnOrderMapper;
import com.ruoyi.business.xhnnotsingle.order.domain.XhnOrder;
import com.ruoyi.business.xhnnotsingle.order.service.IXhnOrderService;
import com.ruoyi.common.core.text.Convert;

/**
 * 微信充值订单Service业务层处理
 *
 * @author ruoyi
 * @date 2022-11-29
 */
@Service
public class XhnOrderServiceImpl implements IXhnOrderService {
    @Autowired
    private XhnOrderMapper xhnOrderMapper;

    /**
     * 查询微信充值订单
     *
     * @param orderCode 微信充值订单主键
     * @return 微信充值订单
     */
    @Override
    public XhnOrder selectXhnOrderByOrderCode(String orderCode) {
        return xhnOrderMapper.selectXhnOrderByOrderCode(orderCode);
    }

    /**
     * 查询微信充值订单列表
     *
     * @param xhnOrder 微信充值订单
     * @return 微信充值订单
     */
    @Override
    public List<XhnOrder> selectXhnOrderList(XhnOrder xhnOrder) {
        return xhnOrderMapper.selectXhnOrderList(xhnOrder);
    }

    /**
     * 新增微信充值订单
     *
     * @param xhnOrder 微信充值订单
     * @return 结果
     */
    @Override
    public int insertXhnOrder(XhnOrder xhnOrder) {
            return xhnOrderMapper.insertXhnOrder(xhnOrder);
    }

    /**
     * 修改微信充值订单
     *
     * @param xhnOrder 微信充值订单
     * @return 结果
     */
    @Override
    public int updateXhnOrder(XhnOrder xhnOrder) {
        return xhnOrderMapper.updateXhnOrder(xhnOrder);
    }

    /**
     * 批量删除微信充值订单
     *
     * @param orderCodes 需要删除的微信充值订单主键
     * @return 结果
     */
    @Override
    public int deleteXhnOrderByOrderCodes(String orderCodes) {
        return xhnOrderMapper.deleteXhnOrderByOrderCodes(Convert.toStrArray(orderCodes));
    }

    /**
     * 删除微信充值订单信息
     *
     * @param orderCode 微信充值订单主键
     * @return 结果
     */
    @Override
    public int deleteXhnOrderByOrderCode(String orderCode) {
        return xhnOrderMapper.deleteXhnOrderByOrderCode(orderCode);
    }
}
