package com.ruoyi.business.xhnnotsingle.registeruser.mapper;

import java.util.List;

import com.github.pagehelper.PageInfo;
import com.ruoyi.business.xhn.domain.RegisteruserUnpaid;
import com.ruoyi.business.xhnnotsingle.registeruser.domain.XhnRegisterUser;

/**
 * 小红娘会员注册信息Mapper接口
 *
 * @author ruoyi
 * @date 2022-11-23
 */
public interface XhnRegisterUserMapper {
    /**
     * 查询小红娘会员注册信息
     *
     * @param openid 小红娘会员注册信息主键
     * @return 小红娘会员注册信息
     */
    public XhnRegisterUser selectXhnRegisterUserByOpenid(String openid);

    /**
     * 查询小红娘会员注册信息列表
     *
     * @param xhnRegisterUser 小红娘会员注册信息
     * @return 小红娘会员注册信息集合
     */
    public List<XhnRegisterUser> selectXhnRegisterUserList(XhnRegisterUser xhnRegisterUser);

    /**
     * 新增小红娘会员注册信息
     *
     * @param xhnRegisterUser 小红娘会员注册信息
     * @return 结果
     */
    public int insertXhnRegisterUser(XhnRegisterUser xhnRegisterUser);

    /**
     * 修改小红娘会员注册信息
     *
     * @param xhnRegisterUser 小红娘会员注册信息
     * @return 结果
     */
    public int updateXhnRegisterUser(XhnRegisterUser xhnRegisterUser);

    /**
     * 批量修改注册信息
     *
     * @param xhnRegisterUser 需要修改的数据ID
     * @return 结果
     */
    public int updateisLoginById(XhnRegisterUser xhnRegisterUser);

    /**
     * 删除小红娘会员注册信息
     *
     * @param openid 小红娘会员注册信息主键
     * @return 结果
     */
    public int deleteXhnRegisterUserByOpenid(String openid);

    /**
     * 批量删除小红娘会员注册信息
     *
     * @param openids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteXhnRegisterUserByOpenids(String[] openids);

    /**
     * app端盲盒列表
     *
     * @param registeruserUnpaid 筛选数据
     * @return 结果
     */
    public List<RegisteruserUnpaid> findXhnRegisterUserByApp(RegisteruserUnpaid registeruserUnpaid);
}
