package com.ruoyi.business.xhnnotsingle.registeruser.service.impl;

import java.util.List;


import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.ruoyi.business.xhn.domain.RegisteruserUnpaid;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.business.xhnnotsingle.registeruser.mapper.XhnRegisterUserMapper;
import com.ruoyi.business.xhnnotsingle.registeruser.domain.XhnRegisterUser;
import com.ruoyi.business.xhnnotsingle.registeruser.mapper.XhnRegisterUserMapper;
import com.ruoyi.business.xhnnotsingle.registeruser.service.IXhnRegisterUserService;
import com.ruoyi.common.core.text.Convert;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 小红娘会员注册信息Service业务层处理
 *
 * @author ruoyi
 * @date 2022-11-23
 */
@Service
public class XhnRegisterUserServiceImpl implements IXhnRegisterUserService {
    @Autowired
    private XhnRegisterUserMapper xhnRegisterUserMapper;

    /**
     * 查询小红娘会员注册信息
     *
     * @param openid 小红娘会员注册信息主键
     * @return 小红娘会员注册信息
     */
    @Override
    public XhnRegisterUser selectXhnRegisterUserByOpenid(String openid) {
        return xhnRegisterUserMapper.selectXhnRegisterUserByOpenid(openid);
    }

    /**
     * 查询小红娘会员注册信息列表
     *
     * @param xhnRegisterUser 小红娘会员注册信息
     * @return 小红娘会员注册信息
     */
    @Override
    public List<XhnRegisterUser> selectXhnRegisterUserList(XhnRegisterUser xhnRegisterUser) {
        return xhnRegisterUserMapper.selectXhnRegisterUserList(xhnRegisterUser);
    }

    /**
     * 新增小红娘会员注册信息
     *
     * @param xhnRegisterUser 小红娘会员注册信息
     * @return 结果
     */
    @Override
    public int insertXhnRegisterUser(XhnRegisterUser xhnRegisterUser) {
            return xhnRegisterUserMapper.insertXhnRegisterUser(xhnRegisterUser);
    }

    /**
     * 修改小红娘会员注册信息
     *
     * @param xhnRegisterUser 小红娘会员注册信息
     * @return 结果
     */
    @Override
    public int updateXhnRegisterUser(XhnRegisterUser xhnRegisterUser) {
        return xhnRegisterUserMapper.updateXhnRegisterUser(xhnRegisterUser);
    }

    /**
     * 批量删除小红娘会员注册信息
     *
     * @param openids 需要删除的小红娘会员注册信息主键
     * @return 结果
     */
    @Override
    public int deleteXhnRegisterUserByOpenids(String openids) {
        return xhnRegisterUserMapper.deleteXhnRegisterUserByOpenids(Convert.toStrArray(openids));
    }

    /**
     * 删除小红娘会员注册信息信息
     *
     * @param openid 小红娘会员注册信息主键
     * @return 结果
     */
    @Override
    public int deleteXhnRegisterUserByOpenid(String openid) {
        return xhnRegisterUserMapper.deleteXhnRegisterUserByOpenid(openid);
    }

    /**
     * 修改脱单状态
     *
     * @param xhnRegisterUser 需要删除的数据ID
     * @return 结果
     */
    @Override
    public int updateisLoginById(XhnRegisterUser xhnRegisterUser)
    {
        return xhnRegisterUserMapper.updateisLoginById(xhnRegisterUser);
    }

    @Override
    public List<RegisteruserUnpaid> findXhnRegisterUserByApp(RegisteruserUnpaid registeruserUnpaid) {
        List<RegisteruserUnpaid> list = xhnRegisterUserMapper.findXhnRegisterUserByApp(registeruserUnpaid);
        return list;
    }
}
